// ==UserScript==
// @name         Podcast downloader for polskieradio.pl
// @author       Krzysztof Ostrowski
// @date         June 03, 2015
// @namespace    http://insooth.i365.pl/insooth/
// @include      http://polskieradio.pl/*
// @include      http://www.polskieradio.pl/*
// ==/UserScript==


(function()
{

var run = function() {
  var process = function(icons) {
    if ( (null !== icons) && (0 < icons.length) ) {

      var re = new RegExp('playFile\\(\'[^\']+\',\\s*\'([^\']+)\'')
      var re_flashvars = new RegExp('file=([^&:]+):([^&]+)&')
      var html_class = 'podcast-downloader'
      var html_text = ' Pobierz'
      var html_alt = 'Zapisz podcast jako...'

      var processor = function(urls, re, audio) {

        if ( (null !== urls) && (0 < urls.length) ) {

          for (var i in urls) {

            // embedded flash player
            try {
              var flashvars = null

              if ((true == urls[i].hasAttribute('name'))
                      && ("flashvars" == urls[i].getAttribute('name'))
                      && (true == urls[i].hasAttribute('value')))
              {

                flashvars = decodeURIComponent(urls[i].getAttribute('value'))

                if ((null !== flashvars) && (true == re_flashvars.test(flashvars))) {

                  var matched = re_flashvars.exec(flashvars)

                  if (matched.length >= 2) {

                    var a1_href = document.createAttribute('href')

                    a1_href.value = 'http://static.polskieradio.pl/'
                        + matched[2] + '.' + matched[1]

                    var panel = document.getElementsByClassName("control-player")

                    if (null !== panel) {
                      if (0 == panel[0].getElementsByClassName(html_class).length) {
                        var a1 = document.createElement('a')
                        var a1_alt = document.createAttribute('alt')
                        var a1_class = document.createAttribute('class')
                        a1.textContent = html_text
                        a1_alt.value = html_alt
                        a1_class.value = html_class
                        a1.setAttributeNode(a1_href)
                        a1.setAttributeNode(a1_alt)
                        a1.setAttributeNode(a1_class)

                        panel[0].appendChild(a1)
                      }
                    }
                  }
                }
              }
            } catch(e) {}

            // regular links
            try {
              var url = ""
              var tmp = null
              var flashvars = null
              var parsed = false

              if (urls[i].parentNode.getElementsByClassName(html_class).length > 0) {
                parsed = true
              }

              var precondition = (null !== urls[i]) 
                && ((true == urls[i].hasAttribute('onclick'))
                    || (true == urls[i].hasAttribute('data-media')))
                && (false == parsed);

              if (true == precondition) {
                var a_href = document.createAttribute('href')

                tmp = urls[i].getAttribute('onclick')

                if ((null !== tmp) && (true == re.test(tmp))) {
                  url = re.exec(tmp)[1]

                  a_href.value = 'http://static.polskieradio.pl/'
                      + url + ( (true == audio) ? '.mp3' : '.flv')

                } else {
                  tmp = JSON.parse(urls[i].getAttribute('data-media'))
                  a_href.value = tmp.file
                }

                var a = document.createElement('a')
                var a_alt = document.createAttribute('alt')
                var a_class = document.createAttribute('class')
                a.textContent = html_text
                a_alt.value = html_alt
                a_class.value = html_class
                a.setAttributeNode(a_href)
                a.setAttributeNode(a_alt)
                a.setAttributeNode(a_class)

                urls[i].parentNode.appendChild(a)

              } // if
            } catch (e) {}
          } // for
        } // if
      } // processor

      for (var i in icons) {
        try {
          processor(icons[i].getElementsByTagName("param"), re_flashvars, true)
        } catch (e) {}

        try {
          processor(icons[i].getElementsByClassName("iVCam"), re, false)
        } catch (e) {}

        try {
          processor(icons[i].getElementsByClassName("iSpeaker"), re, true)
        } catch (e) {}

        try {
          processor(icons[i].getElementsByClassName("play"), re, true)
        } catch (e) {}
      }
    }
  }

  process(document.getElementsByTagName("object"))
  process(document.getElementsByClassName("bIcons"))
  process(document.getElementsByClassName("icons"))
  process(document.getElementsByTagName("li"))
  process(document.getElementsByTagName("div"))
}

window.addEventListener("load", function() { run() }, false)
window.addEventListener("DOMContentLoaded", function() { run() }, false)

}) ();
